/*!***************************************************************************
*!
*! FILE NAME  : crt0.S
*!
*! DESCRIPTION: Level 1 and 2 start.
*!
*! ---------------------------------------------------------------------------
*! (C) Copyright 1998-2006, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

	.global crt0    ; Needed because of a bug in binutils
	.global bytes_to_read

	.section .startup, "ax"

crt0:
	ba clear_bss
	nop
	
bytes_to_read:	 .dword 0x12345678

clear_bss:	
	move.d __Sbss, $r9
	move.d __Ebss, $acr
	cmp.d   $acr,$r9
	beq     bss_done 
bss_loop:
	clear.b [$r9+]
	cmp.d   $acr,$r9
	bne     bss_loop 
	nop     

bss_done:
	move.d 0x38017ffc, $sp	; end of intmem - 4 bytes
	jump crt1
	nop	
