/* printf function */
#include "xstdio.h"

static void *
prout(void *stream, const char *buf, size_t n)
{	/* write to file */
  return (fwrite(buf, 1, n, stream) == n ? n : NULL);
}

int 
(printf)(const char *fmt, ...)
{	/* print formatted to stdout */
  int ans;
  va_list ap;
  
  va_start(ap, fmt);
  ans = _Printf(&prout, stdout, fmt, ap);
  va_end(ap);
  return (ans);
}
