#define DESCR_CONTEXT_TX_SAVED_DATA (dma_descr_data*)&tx_descr
#define DESCR_CONTEXT_TX_SAVED_DATA_BUF (char*)&tx_header

struct packet_header_T  /* Size = 38 */
{  
  unsigned char  dest[6];
  unsigned char  src[6];
  unsigned short length;
  unsigned int   snap1;
  unsigned int   snap2;
  unsigned int   tag;                
  unsigned int   seq;
  unsigned int   type;
  unsigned int   id;    
} __attribute__ ((packed));

#define NETWORK_HEADER_LENGTH sizeof(struct packet_header_T)

#ifndef wait_reset_dma
#define wait_reset_dma( n ) \
  /* Reset dma0. */ \
  reg_dma_rw_cfg rw_cfg = REG_RD( dma, regi_dma0, rw_cfg ); \
  rw_cfg.en   = regk_dma_no; \
  rw_cfg.stop = regk_dma_no; \
  REG_WR( dma, regi_dma0, rw_cfg, rw_cfg);
#endif

#define NET_GA_LO_32 0x008c4001
#define NET_GA_HI_16 0x0002

#define TX_BUF_SIZE 1024

