/* _Getmem function -- UNIX version */
#include "xalloc.h"
#include "simcodes.h"

/* UNIX system call */

extern char *heap_start;

static void *
_Sbrk(int d)
{
  char *ret = heap_start;
  
  heap_start+=d;

  return((void*)ret);

}

void *
_Getmem(size_t size)
{	/* allocate raw storage */
  void *p;
  int isize = size;
  
  return (isize <= 0 || (p = _Sbrk(isize)) == (void *)-1
	  ? NULL : p);
}

