#include <stdio.h>
#include <stdarg.h>
#include <time.h>
#include <stdlib.h>
#include <string.h>
#include "seed.h"

char s[256];

#ifndef LIBC_SIM
void 
print_uint(unsigned int u)
{
  printf("%u\n", u);
}

void print_hex(unsigned u)
{
  printf("0x%x\n", u);
}
#endif

int 
main()
{
  FILE *fd;
  FILE *fd2;
  int i;
  fpos_t *p;
  char *str_p;
  struct timeval tv;
  int j;
  char *tmp;

  srand(RAND_SEED);

  /*  tmp = (char*) malloc(0xa0);*/
  /*  for (i=0; i!=0x40; i++)*/
  /*    tmp[i] = (char) i;*/
  
  hook_debug(0);
  
#if 1
  putc('a', stdout);
  putc('b', stdout);
  putc('c', stdout);
  putc('\n', stdout);
  
  print_int(12345678);
  print_hex(0xabcdef);

  print_str("print_str test1.\n");
  print_str("print_str test22.\n");
  print_str("print_str test333.\n");
  print_str("print_str test4444.\n");
#endif

#if 1
  printf("%d\n", 87654321);
#endif


#if 1
  printf("%x\n", 0xfedcba);

  printf("printf test%d.\n", 22);

  printf("printf test1.\n");
  printf("%s test%d.\n", "printf", 333);
  printf("%c%s test%d.\n", 'p', "rintf", 4444);

  printf("##printf %d 0x%x %c##\n", 1, 2 ,'c');
  
  putc('#', stdout);
  putc('\n', stdout);
  puts("##puts##");
  fputs("##fputs stdout##\n", stdout);
  printf("##printf##\n");
  fprintf(stdout, "##fprintf stdout##\n");
#endif

  exit(EXIT_SUCCESS);

#define ASSERT(a) if (!(a)) { exit(EXIT_FAILURE); }

  {
    unsigned c = 0;

#if 0
    ASSERT(memcmp("a", "a", ++c) == 0);
    ASSERT(memcmp("aa", "aa", ++c) == 0);
    ASSERT(memcmp("aaa", "aaa", ++c) == 0);
    ASSERT(memcmp("aaaa", "aaaa", ++c) == 0);
    ASSERT(memcmp("aaaaa", "aaaaa", ++c) == 0);
    ASSERT(c == 5);
    
    c = 0;
    ASSERT(memcmp("a", "b", ++c) != 0);
    ASSERT(memcmp("aa", "ab", ++c) != 0);
    ASSERT(memcmp("aaa", "baa", ++c) != 0);
    ASSERT(memcmp("aaaa", "abaa", ++c) != 0);
    ASSERT(memcmp("aaaaa", "aaaab", ++c) != 0);
    ASSERT(c == 5);
#endif

    /*
       Allocate two static strings. string1 contains a static
       pattern. Copy a random part of string1 to a random part of
       string2, compare the subsets. Change a random character in
       string2, compare again.
       */

    // Constant string in .data
    //           04 03 02 01 00
    // 970   ... 34 33 32 31 30

    // string1 copied from above
    //           80 7f 7e 7d 7c 7b
    // eff7b ... 35 34 33 32 31 30

    // string2 copied from subset in string1
    //                ce cd cc cb
    // efecb       .. 37 36 35 34 

      // cmp
      // eff7e 33
      // efecb 34
      //
    {
      for(i=1; i!= 100; i++) {
	const char string1[] = "0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz0123456789abcdefghijklmnopqrstuvwxyz";
	unsigned last =  strlen(string1);
	char string2[last+32];
      	unsigned size;
	unsigned r1;
	unsigned r2;
	unsigned min;
	unsigned max;
	char *s1;
	char *s2;
	unsigned r;
	  
	/* Get two offsets for the subset in the strings. */
      	r1 = (int)rand()%last;
	while((r2 = (int)rand()%last) == r1);
	
	/* Figure out starting point in the two strings. */
	min = r1 < r2 ? r1 : r2;
	max = r1 < r2 ? r2 : r1;
	
	s1 = &string1[min];
	s2 = &string2[min];
	
	size = max - min;
	
#if 0
	print_uint(i);
	printf("min %u, max %u\n", min, max);
	print_hex((unsigned)s1);
	print_hex((unsigned)s2);
#endif

	/* Copy subset from string1 to string2. */
	memcpy(s2, s1, size);
	
	/* Compare. Should match. */
	if(memcmp(s1, s2, size) != 0) {
	  unsigned i;
	  for(i=0; i!= size; i++) {
	    if (s1[i] != s2[i]) {
	      print_uint(i);
	      print_uint(s1[i]);
	      print_uint(s2[i]);
	      exit(EXIT_FAILURE);
	    }
	  }
	}
	
	/* Change one character in string2 */
	r = (unsigned)(rand()%size);
	//	print_hex(r);
	s2[r] = ~(s2[r]);

	ASSERT(memcmp(s1, s2, size) != 0);
      }
    }
  }
  
  exit(EXIT_SUCCESS);

  /*
    fd = fopen("/h/ronny/asic/sim/libc/foo","w+");
    putc('#', fd);
    putc('\n', fd);
    fputs("##fputs fd##\n", fd);
    fprintf(fd, "##printf##\n");
    fprintf(fd, "##printf %d 0x%x %c##\n", 1, 2 ,'c');
    fprintf(fd, "##fprintf fd##\n");
    fclose(fd);
    */
  
  /*
    if ((fd = fopen("/h/ronny/asic/sim/libc/foo","r")) == NULL) {
    printf("ERROR\n");
    }
    while(!feof(fd)) {
    fscanf(fd, "%c", &i);
    putc(i, stdout);
    i = fgetc(fd);
    putc(i, stdout);
    i = getc(fd);
    putc(i, stdout);
    fgets(s, 256, fd);
    printf(s);
    }
    fclose(fd);
    */

  /*
    rename("/h/ronny/asic/sim/libc/foo", "/h/ronny/asic/sim/libc/bar");
    */

  /*
    gettimeofday(&tv, NULL);
    print_int(tv.tv_sec);
    print_int(tv.tv_usec);
  
    rename("/h/ronny/asic/sim/libc/foo", "/h/ronny/asic/sim/libc/bar");
    fd = fopen("/h/ronny/asic/sim/libc/bar", "r");
    while (!feof(fd)) {
    printf("%s\n", fgets(s, 256, fd));
    }
  
    gettimeofday(&tv, NULL);
    print_int(tv.tv_sec);
    print_int(tv.tv_usec);
  
    */

  /*
    f = freopen("/h/ronny/kalle","rw",f);
    print_int(f);
    fflush(f);
    i = getc(f);
    print_int(i);
    puts("skriv nat");
    str_p = gets(s);
    puts(str_p);
    remove("berra");
    rename("nisse","olle");
    f = tmpfile();
    str_p = tmpnam(NULL);
    printf("tmpnam: %s\n", str_p);
    setvbuf(stdin,NULL, _IOFBF+_IOLBF+_IONBF, 0);
    setbuf(f, NULL);
    printf("jahas");
    fscanf(stdin,"%s",str_p);
    scanf("%s",str_p);
    sscanf(str_p,"%s",s);
    printf("%d %s %s\n",fgetc(stdin),fgets(s,8,stderr),gets(s));
    fputc(7,stderr);
    fputs("hej",stderr);
    getc(stdin);
    putc(getchar(),stdout);
    putchar(8);
    puts("hej");
    ungetc(8,stdin);
    fread(s,8,9,stdin);
    fwrite(s,8,9,stdout);
    fseek(stdin,4,SEEK_SET);
    fseek(stdin,4,SEEK_CUR);
    fseek(stdin,4,SEEK_END);
    fprintf(stderr,"%d %d %d",ftell(stdin),feof(stdin),ferror(stderr));
    rewind(stdin);
    fgetpos(stdin,p);
    fsetpos(stdin,p);
    clearerr(stdin);
    perror(NULL);
    fclose(f);
    */
  return 0;
}

