//==========================================================================
//
//      types.h
//
//      types needed by mtd
//
//==========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000, 2001 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    ricardw@axis.com
// Contributors: ricardw@axis.com
// Date:         2007-09-06
// Purpose:      
// Description:  
//              
// Definitions of types needed by mtd
//
//####DESCRIPTIONEND####
//
//==========================================================================

#ifndef _RFLTYPES_H_
#define _RFLTYPES_H_

#include <stddef.h>

#if 1
//#include <cyg/infra/cyg_type.h>

/* ordinary types */

typedef unsigned char cyg_uint8;
typedef char cyg_int8;
typedef unsigned short cyg_uint16;
typedef short cyg_int16;
typedef unsigned int cyg_uint32;
typedef int cyg_int32;
typedef unsigned long cyg_uint64;
typedef long cyg_int64;

typedef cyg_uint8	uint8_t;
typedef cyg_int8	int8_t;
typedef cyg_uint16	uint16_t;
typedef cyg_int16	int16_t;
typedef cyg_uint32	uint32_t;
typedef cyg_int32	int32_t;
typedef cyg_uint64	uint64_t;
typedef cyg_int64	int64_t;
#endif

typedef uint8_t		u_char;
typedef uint16_t	u_int;
typedef uint32_t	u_long;

typedef uint32_t	off_t;
typedef uint64_t	loff_t;

typedef uint32_t	u_int32_t;
typedef uint16_t	u_int16_t;
typedef uint8_t		u_int8_t;

typedef uint16_t	u16;
typedef uint16_t	u32;


#endif // _RFLTYPES_H_
