/* boot_images.c - Collection of the different boot images
 * Johan Adolfsson Axis Communications AB 
 *  $Id: boot_images.c,v 1.1 2006/01/16 15:01:03 anderson Exp $ 
 */

#include <stdio.h>
#include "boot_images.h"

/* We include the C files here to the size etc. easy */
#include "net_ima.c"
#include "ser_ima.c"
#include "lv2_ima.c"

struct boot_image_info_type boot_image_info[] = 
{
  { INTERNAL_NW,  net_ima, net_ima_size, "Network boot (default)"},
  { INTERNAL_SER, ser_ima, ser_ima_size, "Serial boot"},
  { INTERNAL2,    lv2_ima, lv2_ima_size, "Level2 boot"},

  { NULL, NULL, 0, NULL } /* End of array */
};

  
  
  
