/*****************************************************************************
*!
*! FILE NAME  : debug.h
*!
*! ---------------------------------------------------------------------------
*! Copyright (C) 2004, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

#ifndef DEBUG_H
#define DEBUG_H

/****************** CONSTANT AND MACRO SECTION ******************************/

#define DEBUG(level, x...) do { if (verbose >= level) printf(x); } while (0)

/****************** GLOBAL VARIABLES SECTION ********************************/

extern int verbose;

#endif
/****************** END OF FILE debug.h *************************************/
