# Hey Emacs, this Makefile is in -*- makefile -*- mode!

###########################################################################

ifneq ($(AXIS_BUILDTYPE),host)
INSTALL   = $(AT_PRETTY) install_elinux -p
else
ifneq ($(shell which install_elinux 2>/dev/null),)
INSTALL   = $(AT_PRETTY) install_elinux -p
else
INSTALL   = $(AT_PRETTY) install -p
endif
endif

# -f must be there or some implicit rules will fail:
RM        = $(AT_PRETTY) rm -f
LN        = $(AT_PRETTY) ln
MKNOD     = $(AT_PRETTY) mknod_elinux

###########################################################################

PRETTY    =
AT_PRETTY =

ifeq ($(AXIS_PRETTIFY),yes)
ifneq ($(shell which ccdv 2>/dev/null),)
PRETTY    = ccdv
AT_PRETTY = @$(PRETTY)
endif
endif

###########################################################################
