#ifdef _THIS_IS_NOT_C_SOURCE


# gcc paths
#GCC_PATH := /n/asic/projects/guinness/tools/int/gcc/bin
CC	 := crisv32-axis-linux-gnu-gcc
STRIP	 := bin-cris
AR	 := cris-ar

SWPATH   := /n/asic/projects/guinness/sw
TOPSWPATH:= /n/asic/projects/guinness/design/top/sw/
INCPATH  := -I../include -Iinclude
LIBROOT  := $(SWPATH)/lib
LIBPATH  := -L$(LIBROOT)
CRTPATH  := $(LIBROOT)

CFLAGS	 := -nostdlib -nostdinc -g -march=v32 -O2 -fno-builtin -DUSE_LIBC $(INCPATH) 
LNFLAGS	 := $(LIBS) -Wl,-T../ldscript -Wl,--section-start,.startup=0 $(LIBPATH) 

# LNFLAGS only used for compiling SOS
LNFLAGSSOS	 := $(LIBSSOS) -Wl,-T/n/asic/projects/guinness/sw/ldscript -Wl,--section-start,.text=$(SOS_START) -L$(SOSPATH) -L$(LIBCPATH)

SYM_TAB	 := cris-sym-tab

ifndef NO_IMA_RULE
%.ima: %.out Makefile
	$(STRIP) -o $@ $<
endif

ifndef NO_SYM_RULE
%.sym: %.out Makefile
	$(SYM_TAB) $< > $@
endif

#------------------------------------------------------------------------- copy
COPYDST    = $(addprefix $(RUNDIR)/,$(COPYFILES))
RUNDIR     := .

# Don't include copy rules when RUNDIR is .
ifneq ($(RUNDIR),.)

copy:   $(COPYDST)

$(COPYDST): $(RUNDIR)/%: %
	@echo copy "$< -> $@"
	@if [ -x $< ]; then \
		install -m 0775 $< $@; \
	else \
		install -m 0664 $< $@; \
	fi; \

endif



#endif
