/* rand function */

#include <stdlib.h>
#define RAND_MAX 0x7fffffff
/* the seed */
unsigned long _Randseed = 1;
#define k_rand_a 48271
#define k_rand_m 2147483647
#define k_rand_r 3399         /* r = m mod a */
#define k_rand_q 44488        /* q = m div a */

int rand(void)
{	/* compute pseudo-random value */

  int s = (int) _Randseed;
  if ((s = s % k_rand_q * k_rand_a - s / k_rand_q * k_rand_r) < 0)
    s += k_rand_m;
  _Randseed = (unsigned) s;
  return s - 1;

}
