# 1 "support/xprintf.c"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "support/xprintf.c"


# 1 "include/ctype.h" 1




extern const short _Tolow_tab[];
extern const short _Toup_tab[];
extern const short _Ctype[];
# 4 "support/xprintf.c" 2
# 1 "include/stdlib.h" 1
# 12 "include/stdlib.h"
# 1 "include/stddef.h" 1
# 34 "include/stddef.h"
typedef int ptrdiff_t;
# 62 "include/stddef.h"
typedef unsigned int size_t;
# 90 "include/stddef.h"
typedef long int wchar_t;
# 109 "include/stddef.h"
typedef long fpos_t;
# 13 "include/stdlib.h" 2



# 1 "include/errno.h" 1
# 125 "include/errno.h"
extern int errno;
# 17 "include/stdlib.h" 2


# 1 "/n/asic/projects/guinness/design/top/sw/include/hook.h" 1







int hook_call( unsigned id, unsigned pcnt, ...);

enum hook_ids {
  hook_debug_on = 1,
  hook_debug_off,
  hook_stop_sim_ok,
  hook_stop_sim_fail,
  hook_alloc_shared,
  hook_ptr_shared,
  hook_free_shared,
  hook_file2shared,
  hook_cmp_shared,
  hook_print_params,
  hook_sim_time,
  hook_stop_sim,
  hook_kick_dog,
  hook_dog_timeout,
  hook_rand,
  hook_srand,
  hook_rand_range,
  hook_print_str,
  hook_print_hex,
  hook_cmp_offset_shared,
  hook_fill_random_shared,
  hook_alloc_random_data,
  hook_calloc_random_data,
  hook_print_int,
  hook_print_uint,
  hook_fputc,
  hook_init_fd,
  hook_sbrk,
  hook_print_context_descr,
  hook_print_data_descr,
  hook_print_group_descr,
  hook_fill_shared
};
# 20 "include/stdlib.h" 2
# 1 "include/quick.h" 1
void init_libc();
unsigned random();
# 21 "include/stdlib.h" 2





double atof (const char *s);
int atoi (const char *s);
long atol (const char *s);
double strtod (const char *s, char **endptr);
long strtol (const char *s, char **endptr, int radix);
unsigned long strtoul (const char *s, char **endptr, int radix);
int rand (void);
void srand (unsigned seed);
void * calloc (size_t nitems, size_t size);
void * malloc (size_t size);
void * realloc(void *block, size_t size);
void free (void *block);
void abort (void);
void exit (int status) __attribute__ ((noreturn));
typedef void (* atexit_t)(void);
int atexit (atexit_t func);
int system (const char *command);
char * getenv (const char *name);
void * bsearch(const void *key, const void *base,
                 size_t nelem, size_t width,
                 int (*fcmp)(const void *, const void *));

void qsort (void *base, size_t nelem, size_t width,
                 int (*fcmp)(const void *, const void *));

extern unsigned long _Randseed;
# 66 "include/stdlib.h"
typedef struct {
        long quot;
        long rem;
} ldiv_t;



typedef struct {
        int quot;
        int rem;
} div_t;

extern div_t div (int numer, int denom);
extern __inline__ div_t div (int numer, int denom)
{ div_t res;
  if (denom == 0) errno = 33;
  res.quot = numer / denom; res.rem = numer % denom;
  return res;
}

extern ldiv_t ldiv (long numer, long denom);
extern __inline__ ldiv_t ldiv (long numer, long denom)
{ ldiv_t res;
  if (denom == 0) errno = 33;
  res.quot = numer / denom; res.rem = numer % denom;
  return res;
}
# 5 "support/xprintf.c" 2
# 1 "include/string.h" 1





extern char *strcpy(char *, const char *);
extern char *strncpy(char *, const char *, size_t);
extern char *strcat(char *, const char *);
extern char *strncat(char *, const char *, size_t);
extern int strcmp(const char *, const char *);
extern int strncmp(const char *, const char *, size_t);
extern char *strchr(const char *, int);
extern char *strrchr(const char *, int);
extern size_t strspn(const char *, const char *);
extern size_t strcspn(const char *, const char *);
extern char *strpbrk(const char *, const char *);
extern char *strstr(const char *, const char *);
extern size_t strlen(const char *);
extern char *strerror(int);
extern char *strtok(char *, const char *);

extern void *memcpy(void *, const void *, size_t);
extern void *memmove(void *, const void *, size_t);
extern int memcmp(const void *, const void *, size_t);
extern void *memchr(const void *, int, size_t);
extern void *memset(void *, int, size_t);
# 6 "support/xprintf.c" 2
# 1 "include/xstdio.h" 1

# 1 "include/stdarg.h" 1





# 1 "include/varargs.h" 1
# 15 "include/varargs.h"
typedef void * __va___list;
# 7 "include/stdarg.h" 2
# 3 "include/xstdio.h" 2
# 1 "include/stdio.h" 1
# 28 "include/stdio.h"
typedef char *FILE;

extern FILE *stdin;
extern FILE *stdout;
extern FILE *stderr;
# 54 "include/stdio.h"
extern FILE *fopen(const char *, const char *);
extern FILE *freopen(const char *, const char *, FILE *);
extern int fflush(FILE *);
extern int fclose(FILE *);
extern int remove(const char *);
extern int rename(const char *, const char *);
extern FILE *tmpfile(void);
extern char *tmpnam(char *s);
extern int setvbuf(FILE *, char *, int, size_t);
extern void setbuf(FILE *, char *);
extern int fprintf(FILE *, const char *, ...);
extern int printf(const char *, ...);
extern int sprintf(char *, const char *, ...);
extern int vprintf(const char *, __va___list);
extern int vfprintf(FILE *, const char *, __va___list);
extern int vsprintf(char *, const char *, __va___list);
extern int fscanf(FILE *, const char *, ...);
extern int scanf(const char *, ...);
extern int sscanf(const char *, const char *, ...);
extern int fgetc(FILE *);
extern char *fgets(char *, int, FILE *);
extern int fputc(int, FILE *);




extern char *gets(char *);




extern void clearerr(FILE *);
extern int feof(FILE *);
extern int ferror(FILE *);
extern int fgetpos(FILE *, fpos_t *);
extern int fputs(const char *, FILE *);
extern size_t fread(void *, size_t, size_t, FILE *);
extern int fseek(FILE *, long, int);
extern int fsetpos(FILE *, const fpos_t *);
extern long ftell(FILE *);
extern size_t fwrite(const void *, size_t, size_t, FILE *);
extern void perror(const char *);
extern int puts(const char *);
extern void rewind(FILE *);
extern int ungetc(int, FILE *);
extern long _Fgpos(FILE *, fpos_t *);
extern int _Fspos(FILE *, const fpos_t *, long, int);
# 4 "include/xstdio.h" 2
# 45 "include/xstdio.h"
typedef struct {
        union {
                long li;
                long double ld;
                } v;
        char *s;
        int n0, nz0, n1, nz1, n2, nz2, prec, width;
        size_t nchar;
        unsigned int flags;
        char qual;
        } _Pft;
typedef struct {
        int (*pfn)(void **, int);
        void *arg;
        __va___list ap;
        int nchar, nget, width;
        char noconv, qual, stored;
        } _Sft;
typedef struct {
        unsigned char _State;
        unsigned short _Wchar;
        } _Mbsave;






FILE *_Foprep(const char *, const char *, FILE *);
int _Fopen(const char *, unsigned int, const char *);
int _Frprep(FILE *);
int _Ftmpnam(char *, int);
int _Fwprep(FILE *);
void _Genld(_Pft *, char, char *, short, short);
const char *_Getfld(_Sft *, const char *);
int _Getfloat(_Sft *);
int _Getint(_Sft *, char);
void _Ldtob(_Pft *, char);
void _Litob(_Pft *, char);
int _Printf(void *(*)(void *, const char *, size_t),
        void *, const char *, __va___list);
void _Putfld(_Pft *, __va___list *, char, char *);
int _Scanf(int (*)(void **, int),
        void *, const char *, __va___list);
# 7 "support/xprintf.c" 2
# 25 "support/xprintf.c"
static char spaces[] = "                                ";
static char zeroes[] = "00000000000000000000000000000000";
# 36 "support/xprintf.c"
int
_Printf(void *(*pfn)(void *, const char *, size_t),
        void *fd, const char *fmt, __va___list ap)
{
  _Pft x;

  for (x.nchar = 0; ; )
    {
      const char *s = fmt;
      {
        int n;
        wchar_t wc;
        _Mbsave state = {0};
        while (0 < (n = ((wc = *s) ? 1 : 0)))
          {
            s += n;
            if (wc == '%')
              {
                --s;
                break;
              }
          }

        if (0 < (s - fmt)) { if (((*pfn)(fd, fmt, s - fmt)) != ((void *)0)) { x.nchar += (s - fmt); } else { exit(23); return (x.nchar); } };
        if (n <= 0)
          return (x.nchar);
        fmt = ++s;
      }

      {
        const char *t;
        static const char fchar[] = {" +-#0"};
        static const unsigned int fbit[] = {
          0x01, 0x02, 0x04, 0x08, 0x10, 0};

        for (x.flags = 0; (t = strchr(fchar, *s)) != ((void *)0); ++s)
          x.flags |= fbit[t - fchar];
        if (*s == '*')
          {
            x.width = __extension__ ({ int __va_temp; (sizeof(__va_temp) > sizeof(long)) ? (__va_temp = **((int **) (ap))) : (__va_temp = *((int *) (ap))); ((long *) (ap))++; __va_temp;});
            if (x.width < 0)
              {
                x.width = -x.width;
                x.flags |= 0x04;
              }
            ++s;
          }
        else
          for (x.width = 0; (_Ctype[(unsigned char)(*s)] & 0x20); ++s)
            if (x.width < 999)
              x.width = x.width * 10 + *s - '0';
        if (*s != '.')
          x.prec = -1;
        else if (*++s == '*')
          {
            x.prec = __extension__ ({ int __va_temp; (sizeof(__va_temp) > sizeof(long)) ? (__va_temp = **((int **) (ap))) : (__va_temp = *((int *) (ap))); ((long *) (ap))++; __va_temp;});
            ++s;
          }
        else
          for (x.prec = 0; (_Ctype[(unsigned char)(*s)] & 0x20); ++s)
            if (x.prec < 999)
              x.prec = x.prec * 10 + *s - '0';
        x.qual = strchr("hlL", *s) ? *s++ : '\0';
      }
      {
        char ac[32];

        _Putfld(&x, &ap, *s, ac);
        x.width -= x.n0 + x.nz0 + x.n1 + x.nz1 + x.n2 + x.nz2;
        if (!(x.flags & 0x04))
          if (0 < (x.width)) {int i, j = (x.width); for (; 0 < j; j -= i) {i = (sizeof (spaces) - 1) < j ? (sizeof (spaces) - 1) : j; if (0 < (i)) { if (((*pfn)(fd, spaces, i)) != ((void *)0)) { x.nchar += (i); } else { exit(23); return (x.nchar); } }; } };
        if (0 < (x.n0)) { if (((*pfn)(fd, ac, x.n0)) != ((void *)0)) { x.nchar += (x.n0); } else { exit(23); return (x.nchar); } };
        if (0 < (x.nz0)) {int i, j = (x.nz0); for (; 0 < j; j -= i) {i = (sizeof (spaces) - 1) < j ? (sizeof (spaces) - 1) : j; if (0 < (i)) { if (((*pfn)(fd, zeroes, i)) != ((void *)0)) { x.nchar += (i); } else { exit(23); return (x.nchar); } }; } };
        if (0 < (x.n1)) { if (((*pfn)(fd, x.s, x.n1)) != ((void *)0)) { x.nchar += (x.n1); } else { exit(23); return (x.nchar); } };
        if (0 < (x.nz1)) {int i, j = (x.nz1); for (; 0 < j; j -= i) {i = (sizeof (spaces) - 1) < j ? (sizeof (spaces) - 1) : j; if (0 < (i)) { if (((*pfn)(fd, zeroes, i)) != ((void *)0)) { x.nchar += (i); } else { exit(23); return (x.nchar); } }; } };
        if (0 < (x.n2)) { if (((*pfn)(fd, x.s + x.n1, x.n2)) != ((void *)0)) { x.nchar += (x.n2); } else { exit(23); return (x.nchar); } };
        if (0 < (x.nz2)) {int i, j = (x.nz2); for (; 0 < j; j -= i) {i = (sizeof (spaces) - 1) < j ? (sizeof (spaces) - 1) : j; if (0 < (i)) { if (((*pfn)(fd, zeroes, i)) != ((void *)0)) { x.nchar += (i); } else { exit(23); return (x.nchar); } }; } };
        if (x.flags & 0x04)
          if (0 < (x.width)) {int i, j = (x.width); for (; 0 < j; j -= i) {i = (sizeof (spaces) - 1) < j ? (sizeof (spaces) - 1) : j; if (0 < (i)) { if (((*pfn)(fd, spaces, i)) != ((void *)0)) { x.nchar += (i); } else { exit(23); return (x.nchar); } }; } };
      }
      fmt = s + 1;
    }
}
