//=============================================================================
//
//	hal_misc.c
//
//	HAL miscellaneous functions
//
//=============================================================================

/*
 * - Please observe -
 * This file is a copy from the CRIS architecture and 
 * yet not ported to the CRISv32 architecture. 
 */

#include <reg_map.h>
#include <vcpu.h>
#include <timer_defs.h>

/*---------------------------------------------------------------------------*/
/* Microsecond delay, stolen from other code                                 */
void hal_delay_us(unsigned int tics)
{
  unsigned int t0 = REG_RD(timer, regi_timer, r_time);
  while (REG_RD(timer, regi_timer, r_time) - t0 < (tics*100))
    ;
}

/*---------------------------------------------------------------------------*/
/* End of hal_misc.c                                                         */
