//==========================================================================
//
//      ioaccess.h
//
//      io access stuff for mtd
//
//==========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000, 2001 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    ricardw@axis.com
// Contributors: ricardw@axis.com
// Date:         2007-09-06
// Purpose:      
// Description:  
//              
// Definitions of io access stuff for mtd
//
//####DESCRIPTIONEND####
//
//==========================================================================

#ifndef _RFLIOACCESS_H_
#define _RFLIOACCESS_H_

//#include <cyg/infra/cyg_type.h>

#define __iomem

static inline cyg_uint8 readb(const volatile void *addr)
{
	return * (volatile cyg_uint8 *) addr;
}

static inline void writeb(cyg_uint8 b, const volatile void *addr)
{
	* (volatile cyg_uint8 *) addr = b;
}

static inline cyg_uint16 readw(const volatile void *addr)
{
	return * (volatile cyg_uint16 *) addr;
}

static inline void writew(cyg_uint16 w, const volatile void *addr)
{
	* (volatile cyg_uint16 *) addr = w;
}

#endif // _RFLIOACCES_H_
