//==========================================================================
//
//      linuxerr.h
//
//      Linux compatibility error codes for mtd/nand
//
//==========================================================================
//####COPYRIGHTBEGIN####
//                                                                          
// -------------------------------------------                              
// The contents of this file are subject to the Red Hat eCos Public License 
// Version 1.1 (the "License"); you may not use this file except in         
// compliance with the License.  You may obtain a copy of the License at    
// http://www.redhat.com/                                                   
//                                                                          
// Software distributed under the License is distributed on an "AS IS"      
// basis, WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the 
// License for the specific language governing rights and limitations under 
// the License.                                                             
//                                                                          
// The Original Code is eCos - Embedded Configurable Operating System,      
// released September 30, 1998.                                             
//                                                                          
// The Initial Developer of the Original Code is Red Hat.                   
// Portions created by Red Hat are                                          
// Copyright (C) 1998, 1999, 2000, 2001 Red Hat, Inc.                             
// All Rights Reserved.                                                     
// -------------------------------------------                              
//                                                                          
//####COPYRIGHTEND####
//==========================================================================
//#####DESCRIPTIONBEGIN####
//
// Author(s):    ricardw@axis.com
// Contributors: ricardw@axis.com
// Date:         2006-09-06
// Purpose:      
// Description:  
// 
// Error codes used by mtd which are not defined by eCos.
//              
//####DESCRIPTIONEND####
//
//==========================================================================

#ifndef _LINUXERR_H_
#define _LINUXERR_H_

#ifndef	ENOMEM
#define	ENOMEM    401
#endif

#ifndef ENXIO
#define ENXIO     402
#endif

#ifndef EFAULT
#define EFAULT    403
#endif

#ifndef EAGAIN
#define EAGAIN    404
#endif

#ifndef EIO
#define EIO       405
#endif

#ifndef EINVAL
#define EINVAL    406
#endif

#ifndef EBADMSG
#define EBADMSG   407
#endif

#endif /* _LINUXERR_H_ */
