#include <cbl.h>
#include <ser_defs.h>

void 
send_ser_string(char *str)
{
  int i;

  for (i=0; str[i];) {
    { /* waitfor ready */
      reg_ser_r_stat_din r_stat_din;
      do {
	r_stat_din = REG_RD(ser, regi_ser0, r_stat_din);
	
      } while (r_stat_din.tr_rdy == regk_ser_no);
    }
    
    { /* send char */
      reg_ser_rw_dout rw_dout;
      
      rw_dout.data = str[i];
      
      REG_WR(ser, regi_ser0, rw_dout, rw_dout);
      i++;
      
    }
  }
}

void 
send_ser_hex(udword v, byte nl)
{
  int i;
  byte buf[13];
  byte nybble;
  
  buf[0] = '0';
  buf[1] = 'x';
  buf[10] = '\r';
  buf[11] = '\n';
  buf[12] = '\0';
  
  if (nl == FALSE) {
    buf[10] = '\0';
  }
  
  for (i=0; i != 8; i++) {
    nybble = (v >> (i*4)) & 0xf;
    if (nybble > 9) {
      nybble += 7;
    }
    buf[7-i+2] = nybble + '0';
  }
  send_ser_string(buf);
}

