/*****************************************************************************
*!
*! FILE NAME  : file.h
*!
*! DESCRIPTION: Misc file utilities
*!
*! ---------------------------------------------------------------------------
*! Copyright (C) 2004, Axis Communications AB, LUND, SWEDEN
*!***************************************************************************/

#ifndef FILE_H
#define FILE_H

/****************** INCLUDE FILES SECTION ***********************************/

#include <stdio.h>

/****************** EXPORTED FUNCTION DECLARATION SECTION *******************/

char* get_pid_file(unsigned int pid, const char* filename);
char* get_proc_file(const char* filename);
char* find_file(const char* top_path, const char* filename);

#endif
/****************** END OF FILE file.h **************************************/
